package de.unirostock.Prototype.example.gui;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.ButtonGroup;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;
import javax.swing.border.LineBorder;

import de.unirostock.Prototype.example.Holk;
import de.unirostock.Prototype.example.Kogge;
import de.unirostock.Prototype.example.Kraier;
import de.unirostock.Prototype.example.Schnigge;
import de.unirostock.Prototype.example.Ship;



public class PrototypeDefinitionPanel extends javax.swing.JPanel
implements ActionListener, ShipInfoPanelModel
{
	private final static 	Schnigge		PROTO_SCHNIGGE	= new Schnigge();
	private final static 	Kraier			PROTO_KRAIER	= new Kraier();
	private final static 	Kogge			PROTO_KOGGE		= new Kogge();
	private final static 	Holk			PROTO_HOLK		= new Holk();
	private Ship			itsPrototype	= PROTO_SCHNIGGE;
	
	private final static 	String		MATERIAL_OAK	= "Eiche";
	private final static 	String		MATERIAL_PINE	= "Kiefer";
	private String			itsMaterial	= MATERIAL_OAK;
	
	private JRadioButton	rbtSchnigge;
	private JRadioButton	rbtKraier;
	private JRadioButton	rbtKogge;
	private JRadioButton	rbtHolk;

	private JRadioButton	rbtMaterialOak;
	private JRadioButton	rbtMaterialPine;
	private JTextField		tfShipName;
	
	private final static	String	BT_SCHNIGGE	= "BT_SCHNIGGE";
	private final static	String	BT_KRAIER	= "BT_KRAIER";
	private final static	String	BT_KOGGE	= "BT_KOGGE";
	private final static	String	BT_HOLK		= "BT_HOLK";

	private final static	String	BT_OAK		= "BT_OAK";
	private final static	String	BT_PINE		= "BT_PINE";

	public PrototypeDefinitionPanel() {
		super();
		initGUI();
	}
	
	public Ship getShipPrototype(){
		return itsPrototype;
	}
	
	public String getShipMaterial(){
		return itsMaterial;
	}
	
	public String getShipName(){
		return tfShipName.getText();
	}
	
	public void actionPerformed( ActionEvent e ){
		String	cmd	= e.getActionCommand();
		
		if( cmd.equals( BT_SCHNIGGE )){
			itsPrototype	= PROTO_SCHNIGGE;
			return;
		}
		if( cmd.equals( BT_KRAIER )){
			itsPrototype	= PROTO_KRAIER;
			return;
		}
		if( cmd.equals( BT_KOGGE )){
			itsPrototype	= PROTO_KOGGE;
			return;
		}
		if( cmd.equals( BT_HOLK )){
			itsPrototype	= PROTO_HOLK;
			return;
		}
		if( cmd.equals( BT_OAK )){
			itsMaterial	= MATERIAL_OAK;
			return;
		}
		if( cmd.equals( BT_PINE )){
			itsMaterial	= MATERIAL_PINE;
			return;
		}
	}
	
	private void initGUI() {
		try {
			this.setLayout(null);
			this.setPreferredSize(new java.awt.Dimension(660, 306));
			this.setBackground(new java.awt.Color(250,248,238));
			{
				JLabel imgLabSchnigge = new JLabel();
				this.add(imgLabSchnigge);
				imgLabSchnigge.setIcon(new ImageIcon(getClass().getClassLoader().getResource("images/Schnigge_book.gif")));
				imgLabSchnigge.setBounds(20, 20, 151, 59);
				imgLabSchnigge.setSize(151, 59);
			}
			{
				rbtSchnigge = new JRadioButton();
				this.add(rbtSchnigge);
				rbtSchnigge.setActionCommand( BT_SCHNIGGE );
				rbtSchnigge.addActionListener( this );
				rbtSchnigge.setText("Prototyp Schnigge");
				rbtSchnigge.setSelected( true );
				rbtSchnigge.setBounds(181, 35, 130, 30);
				rbtSchnigge.setFont(new java.awt.Font("Arial",0,12));
				rbtSchnigge.setBackground(new java.awt.Color(250,248,238));
			}
			{
				JLabel imgLabKraier = new JLabel();
				this.add(imgLabKraier);
				imgLabKraier.setIcon(new ImageIcon(getClass().getClassLoader().getResource("images/Kraier_book.gif")));
				imgLabKraier.setBounds(20, 89, 151, 59);
			}
			{
				rbtKraier = new JRadioButton();
				this.add(rbtKraier);
				rbtKraier.setActionCommand( BT_KRAIER );
				rbtKraier.addActionListener( this );
				rbtKraier.setText("Prototyp Kraier");
				rbtKraier.setBounds(181, 104, 130, 30);
				rbtKraier.setFont(new java.awt.Font("Arial",0,12));
				rbtKraier.setBackground(new java.awt.Color(250,248,238));
			}
			{
				JLabel imgLabKogge = new JLabel();
				this.add(imgLabKogge);
				imgLabKogge.setIcon(new ImageIcon(getClass().getClassLoader().getResource("images/Kogge_book.gif")));
				imgLabKogge.setBounds(20, 158, 151, 59);
			}
			{
				rbtKogge = new JRadioButton();
				this.add(rbtKogge);
				rbtKogge.setActionCommand( BT_KOGGE );
				rbtKogge.addActionListener( this );
				rbtKogge.setText("Prototyp Kogge");
				rbtKogge.setBounds(181, 173, 130, 30);
				rbtKogge.setFont(new java.awt.Font("Arial",0,12));
				rbtKogge.setBackground(new java.awt.Color(250,248,238));
			}
			{
				JLabel imgLabHolk = new JLabel();
				this.add(imgLabHolk);
				imgLabHolk.setIcon(new ImageIcon(getClass().getClassLoader().getResource("images/Holk_book.gif")));
				imgLabHolk.setBounds(20, 227, 151, 59);
			}
			{
				rbtHolk = new JRadioButton();
				this.add(rbtHolk);
				rbtHolk.setActionCommand( BT_HOLK );
				rbtHolk.addActionListener( this );
				rbtHolk.setText("Prototyp Holk");
				rbtHolk.setBounds(181, 242, 130, 30);
				rbtHolk.setFont(new java.awt.Font("Arial",0,12));
				rbtHolk.setBackground(new java.awt.Color(250,248,238));
			}
			{
				JLabel imgLabFactory = new JLabel();
				this.add(imgLabFactory);
				imgLabFactory.setIcon(new ImageIcon(getClass().getClassLoader().getResource("images/shipFactory.gif")));
				imgLabFactory.setBounds(336, 20, 304, 108);
			}
			{
				JPanel specPanel = new JPanel();
				this.add(specPanel);
				specPanel.setBounds(336, 158, 304, 128);
				specPanel.setBackground(new java.awt.Color(255,255,255));
				specPanel.setBorder(new LineBorder(new java.awt.Color(0,0,0), 1, false));
				specPanel.setLayout(null);
				{
					JLabel labText1 = new JLabel();
					specPanel.add(labText1);
					labText1.setText("Spezifikationen fr neue Instanzen:");
					labText1.setBounds(10, 5, 198, 16);
					labText1.setBackground(new java.awt.Color(250, 248, 238));
				}
				{
					JLabel labText2 = new JLabel();
					specPanel.add(labText2);
					labText2.setText("Material:");
					labText2.setBounds(40, 35, 80, 20);
				}
				{
					rbtMaterialOak = new JRadioButton();
					specPanel.add(rbtMaterialOak);
					rbtMaterialOak.setActionCommand( BT_OAK );
					rbtMaterialOak.addActionListener( this );
					rbtMaterialOak.setSelected( true );
					rbtMaterialOak.setText("Eiche");
					rbtMaterialOak.setBounds(130, 35, 80, 20);
					rbtMaterialOak.setBackground(new java.awt.Color(255,255,255));
					rbtMaterialOak.setFont(new java.awt.Font("Arial",0,12));
				}
				{
					rbtMaterialPine = new JRadioButton();
					specPanel.add(rbtMaterialPine);
					rbtMaterialPine.setActionCommand( BT_PINE );
					rbtMaterialPine.addActionListener( this );
					rbtMaterialPine.setText("Kiefer");
					rbtMaterialPine.setBounds(130, 60, 80, 20);
					rbtMaterialPine.setBackground(new java.awt.Color(255,255,255));
					rbtMaterialPine.setFont(new java.awt.Font("Arial",0,12));
				}
				{
					JLabel labText3 = new JLabel();
					specPanel.add(labText3);
					labText3.setText("Schiffsname:");
					labText3.setBounds(40, 90, 80, 20);
				}
				{
					tfShipName = new JTextField();
					specPanel.add(tfShipName);
					tfShipName.setText("Sausewind");
					tfShipName.setBounds(130, 90, 140, 20);
					tfShipName.setBackground(new java.awt.Color(250,248,238));
				}
				{
					ButtonGroup	btGroupPrototypes	= new ButtonGroup();
					btGroupPrototypes.add( rbtSchnigge );
					btGroupPrototypes.add( rbtKraier );
					btGroupPrototypes.add( rbtKogge );
					btGroupPrototypes.add( rbtHolk );
				}
				{
					ButtonGroup	btGroupMaterials	= new ButtonGroup();
					btGroupMaterials.add( rbtMaterialOak );
					btGroupMaterials.add( rbtMaterialPine );
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
